Index: examples/python_tests/experiment_create_rt0/attr.py
===================================================================
--- examples/python_tests/experiment_create_rt0/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/experiment_create_rt0/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,6 @@
 
 """
-  to test with python
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
 
 cmd1:env keystore=`pwd` ./attr.py 
@@ -10,10 +11,12 @@
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
-ctxt.load_directory(keystore)
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
 
 out = ctxt.context_principals()
@@ -29,4 +32,5 @@
 print "\n"
 
+# retrieve principals' keyid value from local credential files
 acmeID=ABAC.ID("Acme_ID.pem");
 acmeID.id_load_privkey_file("Acme_private.pem");
@@ -46,12 +50,24 @@
 
 ################################################
+# Credential 1, Anyone who is allowed to create experiment by Acme's
+#               partners can create experiment at Acme
 # [keyid:Acme].role:experiment_create 
 #           <- [keyid:Acme].role:partner.role:experiment_create
 head=ABAC.Role(acme,"experiment_create")
+
+# creating a linking role
 tail = ABAC.Role(acme,"partner","experiment_create")
+
+# compose the policy attribute
 attr=ABAC.Attribute(head, 1800)
 attr.attribute_add_tail(tail)
+
+# finalize the policy
 attr.attribute_bake()
+
+# write out the policy to an external file
 attr.attribute_write_cert("Acme_experiment_create__Acme_partner_experiment_create_attr.der")
+
+# load the policy into the context by accessing that external file
 ctxt.load_attribute_file("Acme_experiment_create__Acme_partner_experiment_create_attr.der")
 print attr.string() 
@@ -60,4 +76,5 @@
 
 #################################################
+# Credential 2
 # [keyid:Acme].role:partner <- [keyid:Globotron]
 #
@@ -74,7 +91,10 @@
 
 #################################################
+# Credential 3
 # [keyid:Globotron].role:expriment_create 
 #           <- [keyid:Globotron].role:admin.role:power_user
 head = ABAC.Role(acme,"experiment_create")
+
+# a linking role
 tail = ABAC.Role(globotron,"admin","power_user")
 attr=ABAC.Attribute(head, 1800)
@@ -88,6 +108,9 @@
 
 #################################################
+# Credential 4, named term at the right
 # [keyid:Globotron].role:admin <- [keyid:Alice]
 head = ABAC.Role(globotron,"admin")
+
+# the named role is using keyid of alice
 tail = ABAC.Role(alice)
 attr=ABAC.Attribute(head, 1800)
@@ -113,4 +136,2 @@
 print "\n"
 
-ctxt.dump_yap_db()
-##
Index: examples/python_tests/experiment_create_rt0/query.py
===================================================================
--- examples/python_tests/experiment_create_rt0/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/experiment_create_rt0/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
@@ -14,10 +14,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# retrieve principals' keyid value from local credential files
 acmeID=ABAC.ID("Acme_ID.pem");
 acmeID.id_load_privkey_file("Acme_private.pem");
@@ -37,4 +41,17 @@
 
 ##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
+
+##########################################################################
+# is alice a admin at Globotron ?
 # role=[keyid:Globotron].role:admin 
 # p=[keyid:Alice]
@@ -47,4 +64,5 @@
 
 ##########################################################################
+# is bob a admin at Globotron ?
 # role=[keyid:Globotron].role:admin 
 # p=[keyid:Bob]
@@ -58,4 +76,5 @@
 
 ##########################################################################
+# can bob create experiment at Acme ?
 # role=[keyid:Acme].role:experiment_create 
 # p=[keyid:Bob]
@@ -66,19 +85,2 @@
 for c in out[1]:
     print "%s <- %s" % (c.head_string(), c.tail_string())
-
-
-##########################################################################
-# dump the loaded principals/policies
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
-for c in out[1]:
-    print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
-
-
Index: examples/python_tests/experiment_create_rt0/run_test
===================================================================
--- examples/python_tests/experiment_create_rt0/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/experiment_create_rt0/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,7 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
-
 
 echo '---setup principals'
Index: examples/python_tests/experiment_create_rt0/setup.py
===================================================================
--- examples/python_tests/experiment_create_rt0/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/experiment_create_rt0/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,7 +2,6 @@
 
 """
-  to test with python
-
-
+See README for the semantics.  This creates principals
+used by the example.
 """
 import os
Index: examples/python_tests/file_read_rt2/README
===================================================================
--- examples/python_tests/file_read_rt2/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/file_read_rt2/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,10 +1,6 @@
-#!/bin/sh
-#
 #####################################################################
-# This example demonstrates using a parameters to control access to files based
-# on the attributes of the principals.  The script creates three principals
-# Alpha, Bob, Maryann and Joe and sets out the access policy.
-# 
-# files are named by URNs and are not principals.
+# This example demonstrates using a parameters to control access to 
+# files based on the attributes of the principals. files are named by 
+# URNs and are not principals.
 # 
 # A principal's access rights are controlled by the Alpha principal.  If a
@@ -13,84 +9,24 @@
 # a file can read it. (Presumably the owner can, too, but that is not encoded
 # here.)
+#
+# The setup.py file creates four principals Alpha, Bob, Maryann and Joe
 # 
-# The example below lays out the policy that the manager of the owner of a file
+# The attr.py file lays out the policy that the manager of the owner of a file
 # can read it in Credential 1. Credential 2 establishes Bob as the manager of
 # Joe. and Credential 3 establishes Joe as the owner of the file.
 #
-# The attached ./run_query file runs 2 queries.  First it confirms that Bob can read
+# The query.py file runs 2 queries.  First it confirms that Bob can read
 # fileA, then it confirms that Maryann cannot. 
 
-# file_read_rt2_typed
-
-# alpha.read(fileA) <-?- Bob
-#[keyid:Alpha].role:read([urn:'file://fileA']) <-?- [keyid:Bob] (yes)
-#[keyid:Alpha].role:read([urn:'file://fileA']) <-?- [keyid:Maryann] (yes)
-
-creddy --generate --cn Alpha
-creddy --generate --cn Bob
-creddy --generate --cn Maryann
-creddy --generate --cn Joe
-
-alpha_keyid=`creddy --keyid --cert Alpha_ID.pem`
-bob_keyid=`creddy --keyid --cert Bob_ID.pem`
-maryann_keyid=`creddy --keyid --cert Maryann_ID.pem`
-joe_keyid=`creddy --keyid --cert Joe_ID.pem`
-
-read_fileA="read([urn:'file://fileA'])"
-managerof_joe="managerOf([keyid:$joe_keyid])"
-ownerof_fileA="ownerOf([urn:'file://fileA'])"
-managerof_qE="managerOf([principal:?E[keyid:$alpha_keyid].role:ownerOf([urn:?F])])"
-
-# alpha.read(?F) <- alpha.managerOf(?E:alpha.ownerOf(?F))
+# file_read_rt2
+#
+# Credential 1 (alpha.read(?F) <- alpha.managerOf(?E:alpha.ownerOf(?F)))
 # [keyid:alpha].role:read([urn:?F])<-
 #    [keyid:alpha].role:managerOf([principal:?E[keyid:alpha].role:ownerOf([urn:?F])]
-# Credential 1
-creddy --attribute \
-       --issuer Alpha_ID.pem --key Alpha_private.pem --role "read([urn:?F])" \
-       --subject-cert Alpha_ID.pem --subject-role "$managerof_qE" \
-       --out Alpha_read_qF__alpha_managerof_qE_attr.der
 
 # Credential 2
 #[keyid:Alpha].role:managerOf([Keyid:Joe]) <- [keyid:Bob]
-creddy --attribute \
-        --issuer Alpha_ID.pem --key Alpha_private.pem --role "$managerof_joe" \
-        --subject-cert Bob_ID.pem \
-        --out Alpha_managerof_Joe__Bob_attr.der
 
 # Credential 3
 #[keyid:Alpha].role:ownerOf([urn:'file://fileA']) <- [keyid:Joe]
-creddy --attribute \
-        --issuer Alpha_ID.pem --key Alpha_private.pem --role "$ownerof_fileA" \
-        --subject-cert Joe_ID.pem \
-        --out Alpha_ownerof_fileA__Joe_attr.der
 
-####################################################################################
-# note:
-# 
-# alpha.read(?F) <- alpha.manager(?E:alpha.owner(?F))
-# [keyid:alpha].role:read([urn:?F])<-
-#       #[keyid:alpha].role:manager([principal:?E[keyid:alpha].role:owner([urn:?F])])
-# 
-# alpha.read(?F) <- alpha.manager(?E) 
-# and alpha.owner(?F) <- ?E
-# 
-# [keyid:alpha].role:read([urn:?F])<-[keyid:?M]
-#     [keyid:alpha].role:manager([principal:?E])<-[keyid:?M]
-#     [keyid:alpha].role:owner([urn:?F])<-[keyid:?E]
-# 
-# isMember(M,role(alpha,read,F)) :-
-#       isMember(M, role(alpha,manager,E)),
-#       isMember(E, role(alpha,owner,F))  <-- constraining rule
-# 
-# alpha.read(?F) <- alpha.manager(?E)
-# alpha.owner(?F) <- ?E
-# 
-# condition like this,
-#          ?E:A.r  needs to be translate into constraining rule,  A.r<-?E
-# 
-# query,
-# alpha.read(fileA) <-?- Bob
-# needs
-# alpha.manager(Joe)<-Bob
-# alpha.owner(fileA)<-Joe
-
Index: examples/python_tests/file_read_rt2/attr.py
===================================================================
--- examples/python_tests/file_read_rt2/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/file_read_rt2/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,6 @@
 
 """
-  to test with python
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
 
 cmd1:env keystore=`pwd` ./attr.py 
@@ -10,10 +11,12 @@
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
-ctxt.load_directory(keystore)
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
 
 out = ctxt.context_principals()
@@ -29,4 +32,5 @@
 print "\n"
 
+# retrieve principals' keyid value from local credential files
 alphaID=ABAC.ID("Alpha_ID.pem")
 alphaID.id_load_privkey_file("Alpha_private.pem");
@@ -47,4 +51,6 @@
 
 ################################################
+# Credential 1, demostrates role constraint on a file, 
+#               manager of the owner of a file can also read that file
 # [keyid:alpha].role:read([urn:?F])<-
 #    [keyid:alpha].role:managerOf([principal:?E[keyid:alpha].role:ownerOf([urn:?F])]
@@ -52,14 +58,28 @@
 head = ABAC.Role(alpha,"read")
 head.role_add_data_term(param)
+
+# create variable data term
 param=ABAC.DataTerm("urn", "F")
-condoset=ABAC.Role(alpha,"ownerOf")
-condoset.role_add_data_term(param)
-cond=ABAC.Constraint(condoset)
+
+# create the constraining role structure
+condrole=ABAC.Role(alpha,"ownerOf")
+condrole.role_add_data_term(param)
+
+# create the constraint
+cond=ABAC.Constraint(condrole)
+
+# build the parameter with constraint
 param=ABAC.DataTerm("principal", "E", cond)
 tail = ABAC.Role(alpha,"managerOf")
 tail.role_add_data_term(param)
+
+# compose attribute policy
 attr=ABAC.Attribute(head, 1800)
 attr.attribute_add_tail(tail)
+
+# finalize the policy
 attr.attribute_bake()
+
+# write out to external file
 attr.attribute_write_cert("Alpha_read_qF__alpha_managerof_qE_attr.der")
 ctxt.load_attribute_file("Alpha_read_qF__alpha_managerof_qE_attr.der")
@@ -69,4 +89,5 @@
 
 #################################################
+# Credential 2, Bob is Joe's manager
 # [keyid:Alpha].role:managerOf([Keyid:Joe]) <- [keyid:Bob]
 #
@@ -85,4 +106,5 @@
 
 #################################################
+# Credential 3, Joe is file's owner
 #[keyid:Alpha].role:ownerOf([urn:'file://fileA']) <- [keyid:Joe]
 #
@@ -100,5 +122,2 @@
 print "\n"
 
-
-ctxt.dump_yap_db()
-##
Index: examples/python_tests/file_read_rt2/query.py
===================================================================
--- examples/python_tests/file_read_rt2/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/file_read_rt2/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
@@ -14,10 +14,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# retrieve principals' keyid value from local credential files
 alphaID=ABAC.ID("Alpha_ID.pem")
 alphaID.id_load_privkey_file("Alpha_private.pem");
@@ -37,4 +41,17 @@
 
 ##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
+
+##########################################################################
+# can Bob read fileA ?
 # role=[keyid:Alpha].role:read([urn:'file://fileA']) 
 # p=[keyid:Bob]
@@ -49,4 +66,5 @@
 
 ##########################################################################
+# can Maryann read fileA ?
 # role=[keyid:Alpha].role:read([urn:'file://fileA']) 
 # p=[keyid:Maryann]
@@ -59,17 +77,2 @@
     print "%s <- %s" % (c.head_string(), c.tail_string())
 
-
-##########################################################################
-# dump the loaded principals/policies 
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
-for c in out[1]:
-    print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
-
Index: examples/python_tests/file_read_rt2/run_test
===================================================================
--- examples/python_tests/file_read_rt2/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/file_read_rt2/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,7 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
-
 
 echo '---setup principals'
Index: examples/python_tests/file_read_rt2/setup.py
===================================================================
--- examples/python_tests/file_read_rt2/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/file_read_rt2/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,7 +2,6 @@
 
 """
-  to test with python
-
-
+See README for the semantics.  This creates principals
+used by the example.
 """
 import os
Index: examples/python_tests/fruits_rt2/README
===================================================================
--- examples/python_tests/fruits_rt2/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/fruits_rt2/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,3 +1,2 @@
-#!/bin/sh
 #
 # This demonstrates assigning objects to object sets (osets) based on their
@@ -9,5 +8,5 @@
 # Credential 1 lays out Mary's policy - she will eat fruits that cost less that
 # or equal to 2.00.  Bob will eat fruits that cost between 1.00 and 5.00, as
-# laid out in Credential 2.  Strictly speaking Bob and Mary's ruls apply to
+# laid out in Credential 2.  Strictly speaking Bob and Mary's rules apply to
 # prices assigned by Ralphs.  Credentials 3-6 are Ralph's price assignments:
 # 
@@ -15,97 +14,32 @@
 # apple               1.50       3
 # kiwi                1.50       4
-# black rsaberry      2.50       5
+# black rasberry      2.50       5
 # navel ornage        0.50       6
 #
-# The attached ./run_query file proves that Mary will eat a naval orange and a kiwi,
+# The query.py file proves that Mary will eat a naval orange and a kiwi,
 # and that Bob will not eat a navel orange (too cheap).  It also proves a apple
 # is priced at 1.50 and that it cannot prove that a green apple is priced at
 # 1.50 (we don't know anything about green apples).
 
-# fruits_rt2_typed
+# fruits_rt2
 
-# mary.what2eat<-?-navel orange  good
-# mary.what2eat<-?-kiwi  good
-# bob.what2eat<-?-navel orange  bad
-# ralphs.fruitprice(1.50)<-?-apple   good
-# ralphs.fruitprice(1.50)<-?-green apple   bad
-
-creddy --generate --cn Mary
-creddy --generate --cn Bob
-creddy --generate --cn Ralphs
-
-mary_keyid=`creddy --keyid --cert Mary_ID.pem`
-bob_keyid=`creddy --keyid --cert Bob_ID.pem`
-ralphs_keyid=`creddy --keyid --cert Ralphs_ID.pem`
-
-fruitprice_qP="fruitprice([float:?P:[..2.00]])"
-fruitprice_qP_2="fruitprice([float:?P:[1.00..5.00]])"
-
+# Credential 1
 # [keyid:mary].oset:what2eat 
 #      <- [keyid:ralphs].oset:fruitprice([float:?P:[..2.00]])
-# Credential 1
-creddy --attribute \
-       --issuer Mary_ID.pem --key Mary_private.pem --oset "what2eat" \
-       --subject-cert Ralphs_ID.pem --subject-oset "$fruitprice_qP" \
-       --out mary_what2eat__ralphs_fruitprice_qP_attr.der
 
+# Credential 2
 # [keyid:bob].oset:what2eat 
 #      <- [keyid:ralphs].oset:fruitprice([float:?P:[1.00..5.00]])
-# Credential 2
-creddy --attribute \
-       --issuer Bob_ID.pem --key Bob_private.pem --oset "what2eat" \
-       --subject-cert Ralphs_ID.pem --subject-oset "$fruitprice_qP_2" \
-       --out bob_what2eat__ralphs_fruitprice_qP_2_attr.der
 
+# Credential 3
 # [keyid:ralphs].oset:fruitprice([float:1.50]) <- [string:'apple']
-# Credential 3
-creddy --attribute \
-        --issuer Ralphs_ID.pem --key Ralphs_private.pem \
-        --oset "fruitprice([float:1.50])" \
-        --subject-obj "[string:'apple']" \
-        --out Ralphs_fruitprice__apple_attr.der
 
+# Credential 4
 # [keyid:ralphs].oset:fruitprice([float:1.50]) <- [string:'kiwi']
-# Credential 4
-creddy --attribute \
-        --issuer Ralphs_ID.pem --key Ralphs_private.pem \
-        --oset "fruitprice([float:1.50])" \
-        --subject-obj "[string:'kiwi']" \
-        --out Ralphs_fruitprice__kiwi_attr.der
 
+# Credential 5
+# [keyid:ralphs].oset:fruitprice([float:2.50]) <- [string:'black rasberry']
 
-# [keyid:ralphs].oset:fruitprice([float:2.50]) <- [string:'black rasberry']
-# Credential 5
-creddy --attribute \
-        --issuer Ralphs_ID.pem --key Ralphs_private.pem \
-        --oset "fruitprice([float:2.50])" \
-        --subject-obj "[string:'black rasberry']" \
-        --out Ralphs_fruitprice__black_rasberry_attr.der
+# Credential 6
+# [keyid:ralphs].oset:fruitprice([float:0.50]) <- [string:'navel orange']
 
-# [keyid:ralphs].oset:fruitprice([float:0.50]) <- [string:'navel orange']
-# Credential 6
-creddy --attribute \
-        --issuer Ralphs_ID.pem --key Ralphs_private.pem \
-        --oset "fruitprice([float:0.50])" \
-        --subject-obj "[string:'navel orange']" \
-        --out Ralphs_fruitprice__navel_orange_attr.der
-
-#####################################################################
-# mary.what2eat <- ralphs.fruitsprice(?P:[..2.00])
-# [keyid:mary].oset:what2eat 
-#      <- [keyid:ralphs].oset:fruitprice([float:?P:[..2.00]])
-#
-# bob.what2eat <- ralphs.fruitsprice(?P:[1.00..5.00])
-# [keyid:bob].oset:what2eat 
-#      <- [keyid:ralphs].oset:fruitprice([float:?P:[1.00..5.00]])
-# 
-# ralphs.fruitprice(1.50)<-apple
-# [keyid:ralphs].oset:fruitprice([float:1.50]) <- [string:'apple']
-#
-# ralphs.fruitprice(2.50)<-black rasberry
-# [keyid:ralphs].oset:fruitprice([float:2.50]) <- [string:'black rasberry']
-#
-# ralphs.fruitprice(0.50)<-navel orange
-# [keyid:ralphs].oset:fruitprice([float:0.50]) <- [string:'navel orange']
-# 
-
Index: examples/python_tests/fruits_rt2/attr.py
===================================================================
--- examples/python_tests/fruits_rt2/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/fruits_rt2/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,4 +2,7 @@
 
 """
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
+
 cmd1:env keystore=`pwd` ./attr.py 
 """
@@ -8,10 +11,12 @@
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
-ctxt.load_directory(keystore)
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
 
 out = ctxt.context_principals()
@@ -27,4 +32,5 @@
 print "\n"
 
+# retrieve principals' keyid value from local credential files
 ralphsID=ABAC.ID("Ralphs_ID.pem");
 ralphsID.id_load_privkey_file("Ralphs_private.pem");
@@ -40,17 +46,32 @@
 
 ################################################
+# Credential 1, what kind of fruit Mary would eat. Anything not costing more
+#               than 2 dollars
 # [keyid:mary].oset:what2eat
 #      <- [keyid:ralphs].oset:fruitprice([float:?P:[..2.00]])
-# [keyid:alpha].role:access([string:'Read'],[urn:'file//fileB']) <- [keyid:bob]
 head = ABAC.Oset(mary,"what2eat")
+
+# initialize a float range constraint
 cond=ABAC.Constraint("float")
+
+# add the upper max to the range, and only the max
 cond.constraint_add_float_max(2.00)
+
+# create the data term with the constraint
 param=ABAC.DataTerm("float", "P", cond)
 tail = ABAC.Oset(ralphs,"fruitprice")
 tail.oset_add_data_term(param)
+
+# compose the attribute policy
 attr=ABAC.Attribute(head, 1800)
 attr.attribute_add_tail(tail)
+
+#finalize the policy
 attr.attribute_bake()
+
+#write out the policy to a credential file
 attr.attribute_write_cert("mary_what2eat__ralphs_fruitprice_qP_attr.der")
+
+# load the rule back into context via credential file
 ctxt.load_attribute_file("mary_what2eat__ralphs_fruitprice_qP_attr.der")
 print attr.string() 
@@ -59,16 +80,24 @@
 
 ################################################
+# Credential 2,
 # [keyid:bob].oset:what2eat
 #      <- [keyid:ralphs].oset:fruitprice([float:?P:[1.00..5.00]])
 head = ABAC.Oset(bob,"what2eat")
+
+# initialze a float range constraint
 cond=ABAC.Constraint("float")
+
+# add the min and max value to the range
 cond.constraint_add_float_min(1.00)
 cond.constraint_add_float_max(5.00)
-print cond.typed_string()
 param=ABAC.DataTerm("float", "P", cond)
 tail = ABAC.Oset(ralphs,"fruitprice")
 tail.oset_add_data_term(param)
+
+#create attribute policy
 attr=ABAC.Attribute(head, 1800)
 attr.attribute_add_tail(tail)
+
+#finalize the policy
 attr.attribute_bake()
 attr.attribute_write_cert("bob_what2eat__ralphs_fruitprice_qP_attr.der")
@@ -79,4 +108,5 @@
 
 #################################################
+# Credential 3
 # [keyid:ralphs].oset:fruitprice([float:1.50]) <- [string:'apple']
 param=ABAC.DataTerm("float", "1.50")
@@ -95,4 +125,5 @@
 
 #################################################
+# Credential 4
 # [keyid:ralphs].oset:fruitprice([float:1.50]) <- [string:'kiwi']
 param=ABAC.DataTerm("float", "1.50")
@@ -111,4 +142,5 @@
 
 #################################################
+# Credential 5
 # [keyid:ralphs].oset:fruitprice([float:2.50]) <- [string:'black berry']
 param=ABAC.DataTerm("float", "2.50")
@@ -127,4 +159,5 @@
 
 #################################################
+# Credential 6
 # [keyid:ralphs].oset:fruitprice([float:0.50]) <- [string:'navel orange']
 param=ABAC.DataTerm("float", "0.50")
@@ -142,5 +175,2 @@
 print "\n"
 
-##
-ctxt.dump_yap_db()
-##
Index: examples/python_tests/fruits_rt2/query.py
===================================================================
--- examples/python_tests/fruits_rt2/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/fruits_rt2/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
@@ -14,10 +14,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# retrieve principals' keyid value from local credential files
 ralphsID=ABAC.ID("Ralphs_ID.pem");
 ralphsID.id_load_privkey_file("Ralphs_private.pem");
@@ -33,4 +37,17 @@
 
 ##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
+
+##########################################################################
+# Would Mary eat navel orange ?
 # oset = [keyid:mary].oset:what2eat 
 # p [string:'navel orange'] 
@@ -45,4 +62,5 @@
 
 ##########################################################################
+# Would Mary eat kiwi ?
 # oset = [keyid:mary].oset:what2eat 
 # p [string:'kiwi'] 
@@ -57,4 +75,5 @@
 
 ##########################################################################
+# Would Bob eat navel orange ?
 # oset = [keyid:bob].oset:what2eat 
 # p [string:'navel orange'] 
@@ -69,4 +88,5 @@
 
 ##########################################################################
+# Is Apple 1.50 at Ralphs ?
 # oset = [keyid:$ralphs].oset:fruitprice([float:1.50]) 
 # p = [string:'apple'] 
@@ -83,4 +103,5 @@
 
 ##########################################################################
+# Is green apple 1.50 at Ralphs ?
 # oset = [keyid:$ralphs].oset:fruitprice([float:1.50]) 
 # p = [string:'green apple'] 
@@ -101,18 +122,2 @@
 #ctxt.dump_yap_db()
 
-##########################################################################
-# dump the loaded principals/policies
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
-for c in out[1]:
-    print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
-
-
-
Index: examples/python_tests/fruits_rt2/run_test
===================================================================
--- examples/python_tests/fruits_rt2/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/fruits_rt2/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,6 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
 
 echo '---setup principals'
Index: examples/python_tests/fruits_rt2/setup.py
===================================================================
--- examples/python_tests/fruits_rt2/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/fruits_rt2/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,4 +2,6 @@
 
 """
+See README for the semantics.  This creates principals
+used by the example.
 """
 import os
